      ' CECHO2.BAS  03-21-88  TEM  Color ECHO for .BAT files.
      ' ----------------------------------------------------------
      ' Contains code specific for QuickBasic 4.0 and later.
      ' Can not use IBM BASCOM anyway; it clears screen at entry!
      ' (c)1988 T E McCormick and distributed for unrestricted use.
      ' Color ECHO for .BAT files.       Does NOT require ANSI.SYS.
      ' Useful to emphasize certain batch file displays with color.
      ' Compile: BC CECHO2;      Link: LINK CECHO2,,,QB.QLB;
      '
      ' Cmd fmt: CECHO $BF "text string 1" $BF " text string 2" ..etc
      '
      '  Where B and F are each 0 to F HEX.  Left digit is background..
      '  ...for example: $12 is green foreground (2) on blue background.
      '             and: $0E is yellow foreground (14) on black (0).
      '
      '  Note: $0A, $0B, $0E, and $0F will show on monochrome CRTs also.
      '  Run BATCOLOR.BAT for examples.
      ' ----------------------------------------------------------
      ' Next 2 statements reqd at beginning of pgm for call interrupt.
      ' $INCLUDE: 'QB.BI'
        DIM InRegs AS RegType, OutRegs AS RegType
      ' ----------------------------------------------------------
      ' ---- Definition of variables: most are not constants. ----
      ' ----------------------------------------------------------
        ON ERROR GOTO ERR.HANDLER
        DEFINT A-Z
        FALSE% = 0
        TRUE% = NOT FALSE%
      '
        ALEN% = 0               ' Length of ALINE$ string
        ALINE$= ""              ' Raw command tail sting image
        BG% = 0                 ' Background color value 0 - 15
        C$ = " "                ' Single character workfield
        CDEC% = 0               ' A char as integer decimal
        CHEX$ = "&H00"          ' A string of 1 unconverted hex byte
        CRLF$ = CHR$(13) + CHR$(10) ' Carriage Return / Line Feed
        CRT.LINE.LEN% = 80      ' Display maximum line length
        CT.LEN% = 128           ' Command Tail Length (in PSP + 80H)
        CT.OFFSET% = 1          ' Offset from PSP + 81H to begin CT
        CTI% = 1                ' Command Tail Index to current char
        FG% = 7                 ' Foreground color value 0 - 15
        FQ% = 5                 ' First Quotation-mark char offset
        OK% = 0                 ' Result workfield for INSTR
        PAD% = 1                ' Pad of spaces length to end of line
        PTEXT$ = ""             ' Text string workfield to be printed
        PTR% = 1                ' Pointer workfield within ALINE$
        SQ% = 6                 ' Offset of 2nd quotation mark
        TBEGIN% = 5             ' Text begins at this offset
        TD% = 1                 ' This parm-set opening dollar sign
        TEND% = 5               ' Text ends   at this offset
      '
      ' ----------------------------------------------------------
      ' ---- Next gets raw command tail (before uppercase!)   ----
      ' ---- The entire command tail beginning with the 1st   ----
      ' ---- dollar sign character "$" is returned in ALINE$. ----
      ' ---- ALINE$ is parsed for the CECHO command syntax.   ----
      ' ---- If reasonable, it returns here.                  ----
      ' ----------------------------------------------------------
        GOSUB CT.GET
      '
        DEF SEG                             ' Failsafe!
        ALEN% = LEN(ALINE$)                 ' ALINE$ length of string
        IF ALEN% < 1 THEN GOTO FMTERR       ' There is no command tail
        PTR% = 1            ' Initialize ALINE$ char pointer to byte 1
      '
      ' -------------------------------------------------------
      ' - DSIGN to end of mainline is loop for each $HH etc. --
      ' -------------------------------------------------------
DSIGN:
        TD% = INSTR(PTR%, ALINE$, "$")      ' This parm set dollar sign
              IF TD% = 0 THEN GOTO ENDRUN   ' Did not find a $ char = done
      ' --------------------------------------------------------
      ' --- Convert each HEX string to an integer using VAL. ---
      ' --------------------------------------------------------
        CHEXB$ = MID$(ALINE$, (TD% + 1), 1)  ' Get hex bg color value in string
        CHEXB$ = "&H" + CHEXB$               ' Add hex prefix to string
        BG% = VAL(CHEXB$)                    ' Leftmost  digit background
        CHEXF$ = MID$(ALINE$, (TD% + 2), 1)  ' Get hex fg color value in string
        CHEXF$ = "&H" + CHEXF$               ' Add hex prefix to string
        FG% = VAL(CHEXF$)                    ' Rightmost digit foreground
        IF BG% < 0 THEN BG% = 0              ' Range checks (tighten for mono)
        IF BG% > 15 THEN BG% = 15
        IF FG% < 0 THEN FG% = 0
        IF FG% > 15 THEN FG% = 15
        IF FG% = BG% THEN FG% = 7 : BG% = 0 ' Prevent black on black etc
        COLOR FG%, BG%                      ' Setting color here
      ' ----------------------------------------------------------
      ' ---  Get (next) text string to display.               ----
      ' ----------------------------------------------------------
        TBEGIN% = INSTR(PTR%, ALINE$, CHR$(34))  ' Look for beginning quote
        IF TBEGIN% = 0 THEN GOTO FMTERR          ' If NO quotation mark
      ' -----------------------------------------------------------
        FQ% = TBEGIN%                       ' Pointer to the 1st "
        TBEGIN% = TBEGIN% + 1               ' Point past the 1st "
        SQ% = INSTR(TBEGIN%, ALINE$, CHR$(34))    ' Find the 2nd "
        IF SQ% < 1 THEN GOTO FMTERR         ' Error: no 2nd "
        TLEN% = (SQ% - TBEGIN%)             ' Text string length
      ' -----------------------------------------------------------
      ' --- We have a $HH color parm and a quoted text string.  ---
      ' -----------------------------------------------------------
        PTEXT$ = MID$(ALINE$, TBEGIN%, TLEN%)
        PRINT PTEXT$;                       ' Without cr/lf
      ' -----------------------------------------------------------
      ' ---                                                     ---
      ' -----------------------------------------------------------
        PTR% = SQ% + 1 ' Set pointer past 2nd " (end) current parms
        GOTO DSIGN     ' Look for another $BF with more text
     
      ' -----------------------------------------------------------
      ' ---  E N D    O F    M A I N L I N E                    ---
      ' -----------------------------------------------------------
      '
ENDRUN:
        GOTO PGMEXIT
      ' -----------------------------------------------------------

FMTERR:
        COLOR 14
        SOUND 50, 7
        PRINT "------------------------------------------------------------"
        PRINT "Format: cecho $BF ";CHR$(34);"quoted-str-1";CHR$(34);
        PRINT              " $BF ";CHR$(34);"quoted-str-2";CHR$(34);" etc."
        PRINT "    or: cecho $BF ";CHR$(34);"just one quoted string";CHR$(34)
        PRINT "------------------------------------------------------------"
        PRINT "...where B and F are hex 0 to F background/foreground.   tem"
        PRINT "------------------------------------------------------------"
        GOTO PGMEXIT
      ' ------------------------------------------------------------
PGMEXIT:
        GOSUB PAD.LINE.BG  ' Print bg color to right edge crt = cr/lf
        SYSTEM
      '
      ' -------------------------------------------------------------
ERR.HANDLER:
        SOUND 50, 7
        PRINT "Cecho Error "; ERR; " at "; ERL
        PRINT "Trying to deal with string: ";ALINE$
        PRINT "Enter  cecho  ...with no parms to see reqd format."
        GOTO PGMEXIT
      '
      ' -------------------------------------------------------------
      ' -- Following prints spaces to extend bg color to right edge--
      ' -------------------------------------------------------------
PAD.LINE.BG:
        IF BG% = 0 THEN PRINT "" : RETURN   ' Don`t bother if black bg
        CRT.LINE.LEN% = 80                  ' Adjust for 132 etc someday
        PAD% = (CRT.LINE.LEN% - POS(0)) + 1 ' Calc size of spaces pad
        PRINT STRING$(PAD%, CHR$(32))       ' Pad entire line with color
        RETURN
      '
      ' -----------------------------------------------------------
PSP.GET:
      ' ----------------------------------------------------------
      ' You MUST include qb.bi BEFORE other code to "call interrupt"!
      ' You MUST dim inregs and outregs too: done above with include.
      ' ----------------------------------------------------------
      '
      ' Set registers for DOS CALL: returns PSP in BX reg.
        InRegs.ax% = &H5100
        CALL INTERRUPT(&H21, InRegs, OutRegs)
        DEF SEG = OutRegs.bx    ' Take notice  <----------------
      '
        RETURN              ' NOTE: Exit with seg pointing to PSP
      ' ------------------------------------------------------------
      '
CT.GET:
      ' --------------------------------------------------------------------
      ' --  Get raw command tail image in PSP: parse it for cecho pgm.    --
      ' --------------------------------------------------------------------
      ' Next parses command tail in PSP to get it without QB`s convers-
      ' ion of it to upper case, ...which we DO NOT want in this case!
      ' We use length byte at PSP+ &H80, and parse the butes beginning
      ' at &H81 for the length in &H80. Since that length includes the
      ' terminating null (CHR$(0)), we stop one byte less than length.
      ' --------------------------------------------------------------------
      '
        GOSUB PSP.GET                           ' Get Prog Seg Prefix Addr
      ' ------------------------------------      Assuming SEG is PSP.
        ALINE$ = ""                             ' Init work field nothing
        FIRST.DOLLAR% = FALSE%                  ' Have not seen one yet
        CT.LEN% = PEEK(128)   ' &H80 is PSP length byte of command tail
        CT.OFFSET% = &H81     ' Offset from PSP to begin (C)ommand (T)ail
      ' ------------------------------------
      '
       FOR FD% = CT.OFFSET% TO (CT.OFFSET% + 128) ' Find first $ char
            C$ = CHR$(PEEK(FD%))                  ' Get one character
            IF C$ = "$" THEN
                FIRST.DOLLAR% = FD%               ' Mark where our 1st char
                GOTO FD.FOUND                     ' Found first $ char
            END IF
       NEXT FD%
       GOTO FMTERR              ' Did not find first $ char
     '
FD.FOUND:
       FOR CTI% = FD% TO (FD% + (CT.LEN% - 1))  ' Command Tail Index
            C$ = CHR$(PEEK(CTI%))               ' Get one character
            IF C$ = CHR$(0) THEN GOTO CT.DONE   ' Null byte is end
            IF C$ = "$" THEN
                FIRST.DOLLAR% = CTI%            ' Mark where our 1st char
            END IF
            IF FIRST.DOLLAR% <> 0 THEN          ' Ignore preceeding junk
                ALINE$ = ALINE$ + C$            ' Add a char to ALINE$
            END IF
        NEXT CTI%
CT.DONE:
      ' -------------------------------------------------------
        DEF SEG                                 ' Restore segment pointer
        RETURN
      '
      ' -------------------------------------------------------

        ' Restore segment pointer
     